[FORMAT "WCOFF"]
[BITS 32]
[INSTRSET "i486p"]
[FILE "low.nas"]
		GLOBAL	_hlt,_cli,_sti,_stihlt,_in8
		GLOBAL	_out8,_eflagsLoad,_eflagsStore,_gdtrLoad,_idtrLoad
		GLOBAL	_int21Asm,_int2cAsm,_cr0Load,_cr0Store,_memTest0
		GLOBAL	_int20Asm,_trLoad,_farjmp,_farcall, _apiAsm
		GLOBAL	_appStart,_int0dAsm,_int0cAsm
		EXTERN	_int21,_int2c,_int20,_api,_int0d
		EXTERN	_int0c

[SECTION .text]
_hlt:
		HLT
		RET

_cli:
		CLI
		RET

_sti:
		STI
		RET

_stihlt:
		STI
		HLT
		RET

_in8:
		MOV		EDX,[ESP+4]
		MOV		EAX,0
		IN		AL,DX
		RET

_out8:
		MOV		EDX,[ESP+4]
		MOV		AL,[ESP+8]
		OUT		DX,AL
		RET

_eflagsLoad:
		PUSHFD
		POP		EAX
		RET

_eflagsStore:
		MOV		EAX,[ESP+4]
		PUSH	EAX
		POPFD
		RET

_gdtrLoad:
		MOV		AX,[ESP+4]
		MOV		[ESP+6],AX
		LGDT	[ESP+6]
		RET

_idtrLoad:
		MOV		AX,[ESP+4]
		MOV		[ESP+6],AX
		LIDT	[ESP+6]
		RET

_int21Asm:
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int21
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		IRETD

_int2cAsm:
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int2c
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		IRETD

_cr0Load:
		MOV		EAX,CR0
		RET

_cr0Store:
		MOV		EAX,[ESP+4]
		MOV		CR0,EAX
		RET

_memTest0:
		PUSH	EDI
		PUSH	ESI
		PUSH	EBX
		MOV		ESI,0xaa55aa55
		MOV		EDI,0x55aa55aa
		MOV		EAX,[ESP+16]
mtloop:
		MOV		EBX,EAX
		ADD		EBX,0x0ffc
		MOV		EDX,[EBX]
		MOV		[EBX],ESI
		XOR		DWORD [EBX],0xffffffff
		CMP		EDI,[EBX]
		JNE		mtfin
		XOR		DWORD [EBX],0xffffffff
		CMP		ESI,[EBX]
		JNE		mtfin
		MOV		[EBX],EDX
		ADD		EAX,0x1000
		CMP		EAX,[ESP+20]
		JBE		mtloop
		POP		EBX
		POP		ESI
		POP		EDI
		RET
mtfin:
		MOV		[EBX],EDX
		POP		EBX
		POP		ESI
		POP		EDI
		RET

_int20Asm:
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int20
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		IRETD

_trLoad:
		LTR		[ESP+4]
		RET

_farjmp:
		JMP		FAR [ESP+4]
		RET

_farcall:
		CALL	FAR	[ESP+4]
		RET

_apiAsm:
		STI
		PUSH	DS
		PUSH	ES
		PUSHAD
		PUSHAD
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_api
		CMP		EAX,0
		JNE		appEnd
		ADD		ESP,32
		POPAD
		POP		ES
		POP		DS
		IRETD

appEnd:
		MOV		ESP,[EAX]
		POPAD
		RET

_appStart:
		PUSHAD
		MOV		EAX,[ESP+36]
		MOV		ECX,[ESP+40]
		MOV		EDX,[ESP+44]
		MOV		EBX,[ESP+48]
		MOV		EBP,[ESP+52]
		MOV		[EBP],ESP
		MOV		[EBP+4],SS
		MOV		ES,BX
		MOV		DS,BX
		MOV		FS,BX
		MOV		GS,BX
		OR		ECX,3
		OR		EBX,3
		PUSH	EBX
		PUSH	EDX
		PUSH	ECX
		PUSH	EAX
		RETF

_int0dAsm:
		STI
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int0d
		CMP		EAX,0
		JNE		appEnd
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		ADD		ESP,4
		IRETD

_int0cAsm:
		STI
		PUSH	ES
		PUSH	DS
		PUSHAD
		MOV		EAX,ESP
		PUSH	EAX
		MOV		AX,SS
		MOV		DS,AX
		MOV		ES,AX
		CALL	_int0c
		CMP		EAX,0
		JNE		appEnd
		POP		EAX
		POPAD
		POP		DS
		POP		ES
		ADD		ESP,4
		IRETD
