/* low.nas */
void hlt(void);
void cli(void);
void sti(void);
void stihlt(void);
int in8(int port);
void out8(int port, int data);
int eflagsLoad(void);
void eflagsStore(int eflags);
void gdtrLoad(int limit, int addr);
void idtrLoad(int limit, int addr);
void int21Asm(void);
void int2cAsm(void);
int cr0Load(void);
void cr0Store(int cr0);
unsigned int memTest0(unsigned int start, unsigned int end);
void int20Asm(void);
void trLoad(int tr);
void farjmp(int eip, int cs);
void farcall(int eip, int cs);
void apiAsm(void);
void appStart(int eip, int cs, int esp, int ds, int *tssEsp0);
void int0dAsm(void);
void int0cAsm(void);
/* memory.c */
#define MEMORIES	0x4090
struct freeinfo {
	unsigned int addr, size;
};
struct memory {
	int frees;
	struct freeinfo free[MEMORIES];
};
unsigned int memTest(unsigned int start, unsigned int end);
void memInit(struct memory *mem);
unsigned int memTotal(struct memory *mem);
unsigned int memAlloc(struct memory *mem, unsigned int size);
void memFree(struct memory *mem, unsigned int addr, unsigned int size);
/* graphic.c */
#define SHEETS		64
struct sheet {
	unsigned char *buf;
	int x, y, sizex, sizey, cinv, height, flag;
};
struct sheets {
	int top;
	unsigned char *map;
	struct sheet *sht[SHEETS], sheet[SHEETS];
};
#define _000000		0
#define _FF0000		1
#define _00FF00		2
#define _FFFF00		3
#define _0000FF		4
#define _FF00FF		5
#define _00FFFF		6
#define _FFFFFF		7
#define _C6C6C6		8
#define _840000		9
#define _008400		10
#define _848400		11
#define _000084		12
#define _840084		13
#define _008484		14
#define _848484		15
#define SHTUSE		1
void paletteInit(void);
void paletteSet(unsigned char *rgb, int start, int end);
void shtInit(struct memory *mem);
struct sheet *shtAlloc(void);
void shtSet(struct sheet *sht, unsigned char *buf, int sizex, int sizey, int cinv);
void shtUpdown(struct sheet *sht, int height);
void shtRefresh(struct sheet *sht, int x0, int y0, int x1, int y1);
void shtRefresh0(int vx0, int vy0, int vx1, int vy1, int h0, int h1);
void shtRefreshmap(int vx0, int vy0, int vx1, int vy1, int h0);
void shtSlide(struct sheet *sht, int x, int y);
void shtFree(struct sheet *sht);
void mouseCursor(struct sheet *sht);
void boxfill(struct sheet *sht, unsigned char c, int x0, int y0, int x1, int y1);
void putfont(struct sheet *sht, unsigned char c, int x, int y, char *font);
void putfonts(struct sheet *sht, int c, int x, int y, unsigned char *s);
void boxframe(struct sheet *sht, int c, int x0, int y0, int x1, int y1);
void winMake(struct sheet *sht, char *s, int act);
void shtPuts(struct sheet *sht, int bc, int c, int x, int y, char *s);
void wtitleMake(struct sheet *sht, char *s, int act);
/* fifo.c */
struct fifo {
	int *buf, size, free, rp, wp;
	struct task *task;
};
void fifoInit(struct fifo *fifo, int *buf, int size, struct task *task);
void fifoPut(struct fifo *fifo, int data);
int fifoGet(struct fifo *fifo);
int fifoStat(struct fifo *fifo);
/* task.c */
#define TASKS		32
#define TLEVELS		4
struct tss {
	int blink, esp0, ss0, esp1, ss1, esp2, ss2, cr3;
	int eip, eflags, eax, ecx, edx, ebx, esp, ebp, esi, edi;
	int es, cs, ss, ds, fs, gs;
	int ldtr, iomap;
};
struct task {
	int sel, flag, pri, lv;
	struct tss tss;
	struct fifo fifo;
	int stack;
	char name[13];
};
struct tlevel {
	int running, now;
	struct task *task[TASKS];
};
struct tasks {
	int now;
	char lvchan;
	struct tlevel level[TLEVELS];
	struct task task[TASKS * TLEVELS];
};
struct task *taskInit(struct memory *mem);
void taskSwitch(void);
struct task *taskAlloc(void);
void taskRun(struct task *task, int lv, int pri);
void taskSleep(struct task *task);
struct task *taskNow(void);
void taskAdd(struct task *task);
void taskRemove(struct task *task);
void taskSwitch0(void);
void taskIdle(void);
/* pekon.h */
#define TIMERS		512
struct segdesc {
	short limitLow, baseLow;
	char baseMid, ar;
	char limitHigh, baseHigh;
};
struct gatedesc {
	short offsetLow, sel;
	char dwCount, ar;
	short offsetHigh;
};
struct mouse {
	unsigned char buf[3], phase;
	int x, y, btn;
};
struct timer {
	struct timer *next;
	unsigned int tout, flag;
	struct fifo *fifo;
	int data;
};
struct timers {
	unsigned int count;
	struct timer *t0, timer[TIMERS];
};
#define PEKONADDR	0x00280000
#define PEKONLIMIT	0x0007ffff
#define SEGRW		0x4092
#define SEGRX		0x409a
#define TSS			0x0089
#define GATEINT		0x008e
#define TALLOC		1
#define TUSING		2
void gdtidtInit(void);
void segdescSet(struct segdesc *sd, unsigned int limit, unsigned int base, int ar);
void gatedescSet(struct gatedesc *gd, unsigned int offset, int sel, int ar);
void picInit(void);
void int21(int *esp);
void int2c(int *esp);
void kbdReady(void);
void keyInit(struct fifo *fifo);
void mouseEnable(struct mouse *mouse);
int mouseDecode(struct mouse *mouse, unsigned char data);
void timersInit(struct memory *mem);
void int20(int *esp);
struct timer *timerAlloc(void);
void timerFree(struct timer *timer);
void timerInit(struct timer *timer, struct fifo *fifo, int data);
void timerSet(struct timer *timer, unsigned int tout);
int *int0d(int *esp);
int *int0c(int *esp);
/* file.c */
struct file {
	unsigned char name[8], ext[3], type;
	char reserve[10];
	unsigned short time, date, cno;
	unsigned int size;
};
#define DISKADDR	0x00100000
void fatRead(int *fat, unsigned char *img);
void fileLoad(struct file *file, int *fat, char *buf, int size);
/* pekon.c */
void rtcRead(unsigned char *t);
void pekontest(struct sheet *sht, int act);
void pekonReload(struct sheet *sht);
void pekonPut(struct sheet *sht, int no, char *s);
void pekonRun(int no, int *fat);
void pekonExec(struct file *file, int *fat);
void pekonExit(struct task *task);
int *api(int edi, int esi, int ebp, int esp, int ebx, int edx, int ecx, int eax);
void taskBMain(struct sheet *sht);
